Applicability of Reliable Server Pooling for Real-Time Distributed Computing
Internet-Draft draft-dreibholz-rserpool-applic-distcomp-32
Thomas Dreibholz
Simula Metropolitan Centre for Digital Engineering
Pilestredet 52
0167 Oslo
Norway
dreibh@simula.no
https://www.simula.no/people/dreibh
30 March 2024
Internet-Draft
This document describes the applicability of the Reliable Server Pooling architecture to manage real-time distributed computing pools and access the resources of such pools.
Introduction
Reliable Server Pooling defines protocols for providing highly available services. The services are located in a pool of redundant servers and if a server fails, another server will take over. The only requirement put on these servers belonging to the pool is that if state is maintained by the server, this state must be transferred to the other server taking over.
The goal is to provide server-based redundancy. Transport and network level redundancy are handled by the transport and network layer protocols.
The application may choose to distribute its traffic over the servers of the pool conforming to a certain policy.
Scope
The scope of this document is to explain the way of using Reliable Server Pooling mechanisms to manage and access pools of Distributed Computing resources.
Terminology
The terms are commonly identified in related work and can be found in the Aggregate Server Access Protocol and Endpoint Handlespace Redundancy Protocol Common Parameters document [RFC5354].
Distributed Computing using RSerPool
Requirements
The application scenario for Distributed Computing is defined as follows:
- Clients generate large computation jobs. Jobs have to be processed by servers as soon as possible (real-time), i.e. unlike concepts like SETI@home [SETIatHome-Website], it is not possible to let clients fetch a job, process it later and may be some day upload the result.
- Jobs may be partitionable, i.e. they can be split up to smaller pieces which can be processed independently and the processing results can be concatenated to the processing result of the complete job. Jobs have to be processed by servers.
- Servers may be unreliable; i.e. user computers may be temporarily added to the pool of computing resources and may be revoked when they are used again by their owners. Furthermore, they may simply disappear because of broken network connections (modems, etc.) or power turned off.
- The processing power of servers in a pool of computing resources may be very heterogeneous, i.e. a few supercomputers and many low-end user PCs.
Maintaining a Distributed Computing pool for the scenario described above arises the following requirements to the pool management:
- It must be possible to manage large server pools, e.g. up to some hundreds or even thousands of servers.
- Due to heterogeneous processing resources within a pool, it must be possible to use appropriate server selection procedures to meaningfully utilize the available resources.
- It must be possible to dynamically add and remove servers.
- Servers may be unreliable, especially when the servers are represented by user PCs. Failover mechanisms are required to continue an interrupted computation session.
Architecture
All requirements for pool and session management of the Distributed Computing scenario defined in the previous section can be fulfilled by the Reliable Server Pooling architecture:
- An efficient implementation of the handlespace management structures allows pools to contain thousands of elements. Handlespace management structures have been proposed, implemented and analyzed in [IJHIT2008], [Dre2006].
- RSerPool allows to specify server selection rules by pool member selection policies [RFC5356]. A set of adaptive and non-adaptive policies is already defined. To fulfill the requirements of new applications, it is also possible to define new policies. Research has already been made on the subject of load distribution efficiency of pool policies in Distributed Computing scenarios: see [Dre2006], [IJAIT2009], [LCN2005], [Tencon2005], [Euromicro2007] for details.
- Dynamic addition and removal of PEs is a feature of RSerPool [RFC5352].
- The control/data channel concept [RFC5351] of RSerPool realizes a session layer. That is, RSerPool already handles the main task of maintaining and monitoring connections between PUs and PEs; the only task of the application layer to provide full failover functionality is to realize an application-dependent failover procedure. By the usage of client-based state synchronization [IJAIT2009], [LCN2002] in the form of ASAP Cookies, a failover may be fully transparent to the PU while only a state restoration is necessary on the PE side. A demo application [RSerPool-Website] using the RSerPool session layer in a Distributed Computing application is described in [Infocom2005].
Limitations
Applying RSerPool for distributed computing applications, the duties of the RSerPool architecture are still limited to the management of pools and independent sessions only. It is in particular a non-goal to provide functionalities like data synchronization among sessions, user authentication, accounting or the support for more than one administrative domain. Such functionalities are considered to be application-specific and are therefore out of the scope of RSerPool.
Reference Implementation
The RSerPool reference implementation RSPLIB, including example Distributed Computing applications, can be found at [RSerPool-Website]. It supports the functionalities defined by [RFC5351], [RFC5352], [RFC5353], [RFC5354] and [RFC5355] as well as the options [I-D.dreibholz-rserpool-asap-hropt], [I-D.dreibholz-rserpool-enrp-takeover] and [I-D.dreibholz-rserpool-delay]. An introduction to this implementation is provided in [Dre2006].
Testbed Platform
A large-scale and realistic Internet testbed platform with support for the multi-homing feature of the underlying SCTP protocol is NorNet. A description of NorNet is provided in [PAMS2013-NorNet], some further information can be found on the project website [NorNet-Website].
Security Considerations
The protocols used in the Reliable Server Pooling architecture only try to increase the availability of the servers in the network. RSerPool protocols do not contain any protocol mechanisms which are directly related to user message authentication, integrity and confidentiality functions. For such features, it depends on the IPSEC protocols or on Transport Layer Security (TLS) protocols for its own security and on the architecture and/or security features of its user protocols.
The RSerPool architecture allows the use of different transport protocols for its application and control data exchange. These transport protocols may have mechanisms for reducing the risk of blind denial-of-service attacks and/or masquerade attacks. If such measures are required by the applications, then it is advised to check the SCTP (see [RFC4960]) applicability statement [RFC3257] for guidance on this issue.
IANA Considerations
This document introduces no additional considerations for IANA.
References
Normative References
[RFC3257]

Stream Control Transmission Protocol Applicability Statement
L. Coene
April 2002
RFC 3257
DOI 10.17487/RFC3257
[RFC4960]

Stream Control Transmission Protocol
R. Stewart, Ed.
September 2007
RFC 4960
DOI 10.17487/RFC4960
[RFC5351]

An Overview of Reliable Server Pooling Protocols
P. Lei
L. Ong
M. Tuexen
T. Dreibholz
September 2008
RFC 5351
DOI 10.17487/RFC5351
[RFC5352]

Aggregate Server Access Protocol (ASAP)
R. Stewart
Q. Xie
M. Stillman
M. Tuexen
September 2008
RFC 5352
DOI 10.17487/RFC5352
[RFC5353]

Endpoint Handlespace Redundancy Protocol (ENRP)
Q. Xie
R. Stewart
M. Stillman
M. Tuexen
A. Silverton
September 2008
RFC 5353
DOI 10.17487/RFC5353
[RFC5354]

Aggregate Server Access Protocol (ASAP) and Endpoint Handlespace Redundancy Protocol (ENRP) Parameters
R. Stewart
Q. Xie
M. Stillman
M. Tuexen
September 2008
RFC 5354
DOI 10.17487/RFC5354
[RFC5355]

Threats Introduced by Reliable Server Pooling (RSerPool) and Requirements for Security in Response to Threats
M. Stillman, Ed.
R. Gopal
E. Guttman
S. Sengodan
M. Holdrege
September 2008
RFC 5355
DOI 10.17487/RFC5355
[RFC5356]

Reliable Server Pooling Policies
T. Dreibholz
M. Tuexen
September 2008
RFC 5356
DOI 10.17487/RFC5356
[I-D.dreibholz-rserpool-asap-hropt]

Handle Resolution Option for ASAP
Thomas Dreibholz
SimulaMet
6 September 2021
Internet-Draft draft-dreibholz-rserpool-asap-hropt-29
[I-D.dreibholz-rserpool-delay]

Definition of a Delay Measurement Infrastructure and Delay-Sensitive Least-Used Policy for Reliable Server Pooling
Thomas Dreibholz
SimulaMet
Xing Zhou
Hainan University
6 September 2021
Internet-Draft draft-dreibholz-rserpool-delay-28
[I-D.dreibholz-rserpool-enrp-takeover]

Takeover Suggestion Flag for the ENRP Handle Update Message
Thomas Dreibholz
SimulaMet
Xing Zhou
Hainan University
6 September 2021
Internet-Draft draft-dreibholz-rserpool-enrp-takeover-26
Informative References
[Dre2006]

Reliable Server Pooling – Evaluation, Optimization and Extension of a Novel IETF Architecture
ThomasDreibholz
7 March 2007
[Euromicro2007]

A Performance Evaluation of RSerPool Server Selection Policies in Varying Heterogeneous Capacity Scenarios
ThomasDreibholz
XingZhou
Erwin PaulRathgeb
29 August 2007
Proceedings of the 33rd IEEE EuroMirco Conference on Software Engineering and Advanced Applications Pages 157-164, ISBN0-7695-2977-1, DOI10.1109/EUROMICRO.2007.9
[IJAIT2009]

Overview and Evaluation of the Server Redundancy and Session Failover Mechanisms in the Reliable Server Pooling Framework
ThomasDreibholz
Erwin PaulRathgeb
June 2009
International Journal on Advances in Internet Technology(IJAIT) Number 1, Volume 2, Pages 1-14, ISSN1942-2652
[IJHIT2008]

An Evaluation of the Pool Maintenance Overhead in Reliable Server Pooling Systems
ThomasDreibholz
Erwin PaulRathgeb
April 2008
SERSC International Journal on Hybrid Information Technology(IJHIT) Number 2, Volume 1, Pages 17-32, ISSN1738-9968
[Infocom2005]

An Application Demonstration of the Reliable Server Pooling Framework
ThomasDreibholz
Erwin PaulRathgeb
16 March 2005
Proceedings of the 24th IEEE INFOCOM
[LCN2002]

An Efficient Approach for State Sharing in Server Pools
ThomasDreibholz
8 November 2002
Proceedings of the 27th IEEE Local Computer Networks Conference(LCN) Pages 348-349, ISBN0-7695-1591-6, DOI10.1109/LCN.2002.1181806
[LCN2005]

On the Performance of Reliable Server Pooling Systems
ThomasDreibholz
Erwin PaulRathgeb
16 November 2005
Proceedings of the IEEE Conference on Local Computer Networks(LCN) 30th Anniversary Pages 200-208, ISBN0-7695-2421-4, DOI10.1109/LCN.2005.98
[Tencon2005]

The Performance of Reliable Server Pooling Systems in Different Server Capacity Scenarios
ThomasDreibholz
Erwin PaulRathgeb
22 November 2005
Proceedings of the IEEE TENCON ISBN0-7803-9312-0, DOI10.1109/TENCON.2005.300939
[PAMS2013-NorNet]

Design and Implementation of the NorNet Core Research Testbed for Multi-Homed Systems
ThomasDreibholz
Ernst GunnarGran
27 March 2013
Proceedings of the 3nd International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) Pages 1094-1100, ISBN978-0-7695-4952-1, DOI10.1109/WAINA.2013.71
[SETIatHome-Website]

SETI@home: Search for Extraterrestrial Intelligence at home
SETI Project
2022
[RSerPool-Website]

Thomas Dreibholz's RSerPool Page
ThomasDreibholz
2022
[NorNet-Website]

NorNet – A Real-World, Large-Scale Multi-Homing Testbed
Thomas Dreibholz
2022